## scons-doc 2.3.1

=== SConstruct ===
#
# SConstruct file to build scons packages during development.
#
# See the README.rst file for an overview of how SCons is built and tested.

copyright_years = '2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014'

# This gets inserted into the man pages to reflect the month of release.
month_year = 'March 2014'

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

import distutils.util
import fnmatch
import os
import os.path
import re
import stat
import sys
import tempfile

import bootstrap

project = 'scons'
default_version = '2.3.1'
copyright = "Copyright (c) %s The SCons Foundation" % copyright_years

platform = distutils.util.get_platform()

SConsignFile()

#
# An internal "whereis" routine to figure out if a given program
# is available on this system.
#
def whereis(file):
    exts = ['']
    if platform == "win32":
        exts += ['.exe']
    for dir in os.environ['PATH'].split(os.pathsep):
        f = os.path.join(dir, file)
        for ext in exts:
            f_ext = f + ext
            if os.path.isfile(f_ext):
                try:
                    st = os.stat(f_ext)
                except:
                    continue
                if stat.S_IMODE(st[stat.ST_MODE]) & 0111:
                    return f_ext
    return None

#
# We let the presence or absence of various utilities determine whether
# or not we bother to build certain pieces of things.  This should allow
# people to still do SCons packaging work even if they don't have all
# of the utilities installed (e.g. RPM).
#
dh_builddeb = whereis('dh_builddeb')
fakeroot = whereis('fakeroot')
gzip = whereis('gzip')
rpmbuild = whereis('rpmbuild')
hg = os.path.exists('.hg') and whereis('hg')
svn = os.path.exists('.svn') and whereis('svn')
unzip = whereis('unzip')
zip = whereis('zip')

#
# Now grab the information that we "build" into the files.
#
date = ARGUMENTS.get('DATE')
if not date:
    import time
    date = time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(time.time()))

developer = ARGUMENTS.get('DEVELOPER')
if not developer:
    for variable in ['USERNAME', 'LOGNAME', 'USER']:
        developer = os.environ.get(variable)
        if developer:
            break

build_system = ARGUMENTS.get('BUILD_SYSTEM')
if not build_system:
    import socket
    build_system = socket.gethostname().split('.')[0]

version = ARGUMENTS.get('VERSION', '')
if not version:
    version = default_version

hg_status_lines = []
svn_status_lines = []

if hg:
    cmd = "%s status --all 2> /dev/null" % hg
    hg_status_lines = os.popen(cmd, "r").readlines()

if svn:
    cmd = "%s status --verbose 2> /dev/null" % svn
    svn_status_lines = os.popen(cmd, "r").readlines()

revision = ARGUMENTS.get('REVISION', '')
def generate_build_id(revision):
    return revision

if not revision and hg:
    hg_heads = os.popen("%s heads 2> /dev/null" % hg, "r").read()
    cs = re.search('changeset:\s+(\S+)', hg_heads)
    if cs:
        revision = cs.group(1)
        b = re.search('branch:\s+(\S+)', hg_heads)
        if b:
            revision = b.group(1) + ':' + revision
        def generate_build_id(revision):
            result = revision
            if [l for l in hg_status_lines if l[0] in 'AMR!']:
                result = result + '[MODIFIED]'
            return result

if not revision and svn:
    svn_info = os.popen("%s info 2> /dev/null" % svn, "r").read()
    m = re.search('Revision: (\d+)', svn_info)
    if m:
        revision = m.group(1)
        def generate_build_id(revision):
            result = 'r' + revision
            if [l for l in svn_status_lines if l[0] in 'ACDMR']:
                result = result + '[MODIFIED]'
            return result

checkpoint = ARGUMENTS.get('CHECKPOINT', '')
if checkpoint:
    if checkpoint == 'd':
        import time
        checkpoint = time.strftime('%Y%m%d', time.localtime(time.time()))
    elif checkpoint == 'r':
        checkpoint = 'r' + revision
    version = version + '.beta.' + checkpoint

build_id = ARGUMENTS.get('BUILD_ID')
if build_id is None:
    if revision:
        build_id = generate_build_id(revision)
    else:
        build_id = ''

python_ver = sys.version[0:3]

#
# Adding some paths to sys.path, this is mainly needed
# for the doc toolchain.
#
addpaths = [os.path.abspath(os.path.join(os.getcwd(), 'bin')),
            os.path.abspath(os.path.join(os.getcwd(), 'QMTest'))]
for a in addpaths:
    if a not in sys.path:
        sys.path.append(a)


# Re-exporting LD_LIBRARY_PATH is necessary if the Python version was
# built with the --enable-shared option.

ENV = { 'PATH' : os.environ['PATH'] }
for key in ['LOGNAME', 'PYTHONPATH', 'LD_LIBRARY_PATH']:
    if key in os.environ:
        ENV[key] = os.environ[key]

build_dir = ARGUMENTS.get('BUILDDIR', 'build')
if not os.path.isabs(build_dir):
    build_dir = os.path.normpath(os.path.join(os.getcwd(), build_dir))

command_line_variables = [
    ("BUILDDIR=",       "The directory in which to build the packages.  " +
                        "The default is the './build' subdirectory."),

    ("BUILD_ID=",       "An identifier for the specific build." +
                        "The default is the Subversion revision number."),

    ("BUILD_SYSTEM=",   "The system on which the packages were built.  " +
                        "The default is whatever hostname is returned " +
                        "by socket.gethostname()."),

    ("CHECKPOINT=",     "The specific checkpoint release being packaged, " +
                        "which will be appended to the VERSION string.  " +
                        "A value of CHECKPOINT=d will generate a string " +
                        "of 'd' plus today's date in the format YYYMMDD.  " +
                        "A value of CHECKPOINT=r will generate a " +
                        "string of 'r' plus the Subversion revision " +
                        "number.  Any other CHECKPOINT= string will be " +
                        "used as is.  There is no default value."),

    ("DATE=",           "The date string representing when the packaging " +
                        "build occurred.  The default is the day and time " +
                        "the SConstruct file was invoked, in the format " +
                        "YYYY/MM/DD HH:MM:SS."),

    ("DEVELOPER=",      "The developer who created the packages.  " +
                        "The default is the first set environment " +
                        "variable from the list $USERNAME, $LOGNAME, $USER."),

    ("REVISION=",       "The revision number of the source being built.  " +
                        "The default is the Subversion revision returned " +
                        "'svn info', with an appended string of " +
                        "'[MODIFIED]' if there are any changes in the " +
                        "working copy."),

    ("VERSION=",        "The SCons version being packaged.  The default " +
                        "is the hard-coded value '%s' " % default_version +
                        "from this SConstruct file."),
]

Default('.', build_dir)

packaging_flavors = [
    ('deb',             "A .deb package.  (This is currently not supported.)"),

    ('rpm',             "A RedHat Package Manager file."),

    ('tar-gz',          "The normal .tar.gz file for end-user installation."),

    ('src-tar-gz',      "A .tar.gz file containing all the source " +
                        "(including tests and documentation)."),

    ('local-tar-gz',    "A .tar.gz file for dropping into other software " +
                        "for local use."),

    ('zip',             "The normal .zip file for end-user installation."),

    ('src-zip',         "A .zip file containing all the source " +
                        "(including tests and documentation)."),

    ('local-zip',       "A .zip file for dropping into other software " +
                        "for local use."),
]

test_deb_dir          = os.path.join(build_dir, "test-deb")
test_rpm_dir          = os.path.join(build_dir, "test-rpm")
test_tar_gz_dir       = os.path.join(build_dir, "test-tar-gz")
test_src_tar_gz_dir   = os.path.join(build_dir, "test-src-tar-gz")
test_local_tar_gz_dir = os.path.join(build_dir, "test-local-tar-gz")
test_zip_dir          = os.path.join(build_dir, "test-zip")
test_src_zip_dir      = os.path.join(build_dir, "test-src-zip")
test_local_zip_dir    = os.path.join(build_dir, "test-local-zip")

unpack_tar_gz_dir     = os.path.join(build_dir, "unpack-tar-gz")
unpack_zip_dir        = os.path.join(build_dir, "unpack-zip")

if platform == "win32":
    tar_hflag = ''
    python_project_subinst_dir = os.path.join("Lib", "site-packages", project)
    project_script_subinst_dir = 'Scripts'
else:
    tar_hflag = 'h'
    python_project_subinst_dir = os.path.join("lib", project)
    project_script_subinst_dir = 'bin'



import textwrap

indent_fmt = '  %-26s  '

Help("""\
The following aliases build packages of various types, and unpack the
contents into build/test-$PACKAGE subdirectories, which can be used by the
runtest.py -p option to run tests against what's been actually packaged:

""")

aliases = sorted(packaging_flavors + [('doc', 'The SCons documentation.')])

for alias, help_text in aliases:
    tw = textwrap.TextWrapper(
        width = 78,
        initial_indent = indent_fmt % alias,
        subsequent_indent = indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

Help("""
The following command-line variables can be set:

""")

for variable, help_text in command_line_variables:
    tw = textwrap.TextWrapper(
        width = 78,
        initial_indent = indent_fmt % variable,
        subsequent_indent = indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')



zcat = 'gzip -d -c'

#
# Figure out if we can handle .zip files.
#
zipit = None
unzipit = None
try:
    import zipfile

    def zipit(env, target, source):
        print "Zipping %s:" % str(target[0])
        def visit(arg, dirname, names):
            for name in names:
                path = os.path.join(dirname, name)
                if os.path.isfile(path):
                    arg.write(path)
        zf = zipfile.ZipFile(str(target[0]), 'w')
        olddir = os.getcwd()
        os.chdir(env['CD'])
        try: os.path.walk(env['PSV'], visit, zf)
        finally: os.chdir(olddir)
        zf.close()

    def unzipit(env, target, source):
        print "Unzipping %s:" % str(source[0])
        zf = zipfile.ZipFile(str(source[0]), 'r')
        for name in zf.namelist():
            dest = os.path.join(env['UNPACK_ZIP_DIR'], name)
            dir = os.path.dirname(dest)
            try:
                os.makedirs(dir)
            except:
                pass
            print dest,name
            # if the file exists, then delete it before writing
            # to it so that we don't end up trying to write to a symlink:

=== doc/design/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('design_xi.xml', 'main.xml')
env.DocbookXslt('design.xml', 'design_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtmlChunked('index.html','design.xml', base_dir='scons-design/')
if has_pdf:
    env.DocbookPdf('scons-design.pdf','design.xml')

=== doc/developer/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'])

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('developer_xi.xml', 'main.xml')
env.DocbookXslt('developer.xml', 'developer_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('developer.html','developer.xml')
if has_pdf:
    env.DocbookPdf('developer.pdf','developer.xml')

=== doc/man/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook','gs','zip'],
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

# Helper function, combining all the steps for a single target
def createManPages(env, target):
    env.DocbookXInclude('%s_xi.xml' % target, '%s.xml' % target)
    env.DocbookXslt('%s_db.xml' % target, '%s_xi.xml' % target, 
                    xsl='../xslt/to_docbook.xslt')
    env.DocbookHtml('scons-%s.html' % target,'%s_db.xml' % target)
    env.DocbookMan('%s.1' % target, '%s_db.xml' % target)
    if has_pdf:
        env.DocbookPdf('scons-%s.pdf' % target,'%s_db.xml' % target)

#
# Create MAN pages
#
createManPages(env, "scons")
createManPages(env, "sconsign")
createManPages(env, "scons-time")

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs('OEBPS/cover.jpg','scons-scons.pdf', 
                 GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q')
    epub = env.DocbookEpub('scons-man.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== doc/python10/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'])

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('python10_xi.xml', 'main.xml')
env.DocbookXslt('python10.xml', 'python10_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('python10.html','python10.xml')
if has_pdf:
    env.DocbookPdf('python10.pdf','python10.xml')

=== doc/reference/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('reference_xi.xml', 'main.xml')
env.DocbookXslt('reference.xml', 'reference_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html','reference.xml')
env.DocbookHtmlChunked('index.html', 'reference.xml', base_dir='scons-reference/')
if has_pdf:
    env.DocbookPdf('scons-reference.pdf','reference.xml')

=== doc/user/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook','gs','zip'], 
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# UserGuide for SCons
#
env.DocbookXInclude('scons_xi.xml', 'main.xml')
env.DocbookXslt('scons_ex.xml', 'scons_xi.xml', 
                xsl='../xslt/xinclude_examples.xslt')
env.DocbookXInclude('scons_exi.xml', 'scons_ex.xml')
env.DocbookXslt('scons_db.xml', 'scons_exi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html','scons_db.xml')
env.DocbookHtmlChunked('index.html', 'scons_db.xml', base_dir='scons-user/')
if has_pdf:
    env.DocbookPdf('scons-user.pdf','scons_db.xml')

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs('OEBPS/cover.jpg','scons-user.pdf', 
                 GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q')
    epub = env.DocbookEpub('scons-user.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== debian/changelog ===
scons-doc (2.3.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/missing-sources/jquery-1.4.2.js,
    debian/missing-sources/jquery-ui-1.8.2.custom.js:
    - Provide missing sources for compressed JavaScript libraries.
  * debian/patches/user_guide.patch:
    - Build User Guide only.
  * debian/control:
    - Build-depends on python-libxml2, python-libxslt1, and fop.
    - Bump Standards-Version to 3.9.5, no changes required.
  * debian/docs:
    - PS files are no longer generated.
  * debian/doc-base:
    - Refresh doc-base with new file locations.
  * debian/rules:
    - Remove .pyc files on clean.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 27 Apr 2014 12:05:51 +0200

=== debian/control ===
Source: scons-doc
Section: doc
Priority: optional
Maintainer: Luca Falavigna <dktrkranz@debian.org>
Uploaders: Mark Brown <broonie@debian.org>
Build-Depends: debhelper (>= 9),
               scons (>= 2.3.1)
Build-Depends-Indep: python-libxml2,
                     python-libxslt1,
                     docbook-utils,
                     fop,
                     jade,
                     docbook-xml
Standards-Version: 3.9.5
Homepage: http://www.scons.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/scons-doc.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/scons-doc.git;a=summary

Package: scons-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: scons (>= 2.3.1)
Description: Documentation for SCons, a replacement for Make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.
 .
 This package provides the SCons User's guide.

=== debian/rules ===
#!/usr/bin/make -f

VERSION = $(shell head -n1 debian/changelog | sed -e 's/.*(//;s/-.*).*//;s/\+/\-/')

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -fr build
	find -name "*.pyc" -delete

override_dh_auto_install:
	scons doc
	rm -fr $(CURDIR)/build/doc/HTML/scons-user

get-orig-source:
	wget http://downloads.sourceforge.net/project/scons/scons-src/${VERSION}/scons-src-${VERSION}.tar.gz -O ../scons-src-${VERSION}.tar.gz
	tar fxz ../scons-src-${VERSION}.tar.gz -C ../ && mv ../scons-src-${VERSION} ../scons-doc-${VERSION}
	tar czf ../scons-doc_${VERSION}.orig.tar.gz ../scons-doc-${VERSION}/bin ../scons-doc-${VERSION}/bootstrap.py \
		../scons-doc-${VERSION}/config ../scons-doc-${VERSION}/doc ../scons-doc-${VERSION}/LICENSE \
		../scons-doc-${VERSION}/QMTest ../scons-doc-${VERSION}/SConstruct ../scons-doc-${VERSION}/src
	rm -fr ../scons-doc-${VERSION} ../scons-src-${VERSION}.tar.gz

## scons-doc 2.3.4

=== SConstruct ===
--- 
+++ 
@@ -3,13 +3,13 @@
 #
 # See the README.rst file for an overview of how SCons is built and tested.
 
-copyright_years = '2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014'
+copyright_years = '2001 - 2014'
 
 # This gets inserted into the man pages to reflect the month of release.
-month_year = 'March 2014'
-
-#
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+month_year = 'September 2014'
+
+#
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the
@@ -43,7 +43,7 @@
 import bootstrap
 
 project = 'scons'
-default_version = '2.3.1'
+default_version = '2.3.4'
 copyright = "Copyright (c) %s The SCons Foundation" % copyright_years
 
 platform = distutils.util.get_platform()
@@ -351,3 +351,6 @@
             print dest,name
             # if the file exists, then delete it before writing
             # to it so that we don't end up trying to write to a symlink:
+            if os.path.isfile(dest) or os.path.islink(dest):
+                os.unlink(dest)
+            if not os.path.isdir(dest):

=== doc/design/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/developer/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/man/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/python10/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/reference/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/user/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 The SCons Foundation
+# Copyright (c) 2001 - 2014 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== debian/changelog ===
scons-doc (2.3.4-1) unstable; urgency=low

  * New maintainer (Closes: #755497).
  * New upstream release
    - Refresh debian/patches/user_guide.patch for new release.
  * debian/control:
    - Set myself as maintainer.
    - Set László Böszörményi as co-maintainer.
    - In Build-Depends and Suggests:
      + Change release of scons to (>= 2.3.1).
    - Bump Standards-Version to 3.9.6 (no changes required).
  * debian/copyright:
    - Rewrite into machine-readable format.
    - Change license for debian/* from GPL to GPL-3.0+.
    - Add myself to the list of authors for debian/*.
    - Update copyright years for 2014-2015.
  * debian/watch
    - Rewrite regex for finding all file extensions.
  * New debian/patches/0100-license.patch (Closes: #787356):
    - Cherry-picked from upstream to make the source DFSG-compliant.
  * Rename debian/patches/user_guide.patch to 0500-user_guide.patch.

 -- Jörg Frings-Fürst <debian@jff-webhosting.net>  Fri, 05 Jun 2015 08:59:29 +0200

=== debian/control ===
Source: scons-doc
Section: doc
Priority: optional
Maintainer: Jörg Frings-Fürst <debian@jff-webhosting.net>
Uploaders: László Böszörményi <gcs@debian.org>
Build-Depends: 
 debhelper (>= 9),
 scons (>= 2.3)
Build-Depends-Indep: 
 docbook-utils,
 docbook-xml,
 fop,
 jade,
 python-libxml2,
 python-libxslt1
Standards-Version: 3.9.6
Homepage: http://www.scons.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/scons-doc.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/scons-doc.git

Package: scons-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: scons (>= 2.3)
Description: Documentation for SCons, a replacement for Make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.
 .
 This package provides the SCons User's guide.

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,12 @@
 get-orig-source:
 	wget http://downloads.sourceforge.net/project/scons/scons-src/${VERSION}/scons-src-${VERSION}.tar.gz -O ../scons-src-${VERSION}.tar.gz
 	tar fxz ../scons-src-${VERSION}.tar.gz -C ../ && mv ../scons-src-${VERSION} ../scons-doc-${VERSION}
-	tar czf ../scons-doc_${VERSION}.orig.tar.gz ../scons-doc-${VERSION}/bin ../scons-doc-${VERSION}/bootstrap.py \
+
+	# remove DFSG-incompatible files
+#	rm -fr ../scons-doc-${VERSION}/doc/user/titlepage/SConsBuildBricks_path.svg ../scons-doc-${VERSION}/doc/design/titlepage/SConsBuildBricks_path.svg \
+#	    ../scons-doc-${VERSION}/doc/man/titlepage/SConsBuildBricks_path.svg ../scons-doc-${VERSION}/doc/reference/titlepage/SConsBuildBricks_path.svg
+
+	tar -caf ../scons-doc_${VERSION}.orig.tar.xz ../scons-doc-${VERSION}/bin ../scons-doc-${VERSION}/bootstrap.py \
 		../scons-doc-${VERSION}/config ../scons-doc-${VERSION}/doc ../scons-doc-${VERSION}/LICENSE \
 		../scons-doc-${VERSION}/QMTest ../scons-doc-${VERSION}/SConstruct ../scons-doc-${VERSION}/src
 	rm -fr ../scons-doc-${VERSION} ../scons-src-${VERSION}.tar.gz

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg(.*)// \
http://sf.net/scons/scons-src-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## scons-doc 2.3.6+repack

=== SConstruct ===
--- 
+++ 
@@ -3,13 +3,13 @@
 #
 # See the README.rst file for an overview of how SCons is built and tested.
 
-copyright_years = '2001 - 2014'
+copyright_years = '2001 - 2015'
 
 # This gets inserted into the man pages to reflect the month of release.
-month_year = 'September 2014'
-
-#
-# Copyright (c) 2001 - 2014 The SCons Foundation
+month_year = 'July 2015'
+
+#
+# Copyright (c) 2001 - 2015 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the
@@ -43,11 +43,17 @@
 import bootstrap
 
 project = 'scons'
-default_version = '2.3.4'
+default_version = '2.3.6'
 copyright = "Copyright (c) %s The SCons Foundation" % copyright_years
 
 platform = distutils.util.get_platform()
 
+def is_windows():
+   if platform.startswith('win'):
+      return True
+   else:
+      return False
+   
 SConsignFile()
 
 #
@@ -56,7 +62,7 @@
 #
 def whereis(file):
     exts = ['']
-    if platform == "win32":
+    if is_windows():
         exts += ['.exe']
     for dir in os.environ['PATH'].split(os.pathsep):
         f = os.path.join(dir, file)
@@ -166,6 +172,14 @@
     else:
         build_id = ''
 
+import os.path
+import distutils.command
+
+no_winpack_templates = not os.path.exists(os.path.join(os.path.split(distutils.command.__file__)[0],'wininst-9.0.exe'))
+skip_win_packages = ARGUMENTS.get('SKIP_WIN_PACKAGES',False) or no_winpack_templates
+if skip_win_packages:
+    print "Skipping the build of Windows packages..."
+
 python_ver = sys.version[0:3]
 
 #
@@ -229,6 +243,8 @@
     ("VERSION=",        "The SCons version being packaged.  The default " +
                         "is the hard-coded value '%s' " % default_version +
                         "from this SConstruct file."),
+
+    ("SKIP_WIN_PACKAGES=", "If set, skip building win32 and win64 packages."),
 ]
 
 Default('.', build_dir)
@@ -267,7 +283,7 @@
 unpack_tar_gz_dir     = os.path.join(build_dir, "unpack-tar-gz")
 unpack_zip_dir        = os.path.join(build_dir, "unpack-zip")
 
-if platform == "win32":
+if is_windows():
     tar_hflag = ''
     python_project_subinst_dir = os.path.join("Lib", "site-packages", project)
     project_script_subinst_dir = 'Scripts'
@@ -331,7 +347,8 @@
                 path = os.path.join(dirname, name)
                 if os.path.isfile(path):
                     arg.write(path)
-        zf = zipfile.ZipFile(str(target[0]), 'w')
+        # default ZipFile compression is ZIP_STORED
+        zf = zipfile.ZipFile(str(target[0]), 'w', compression=zipfile.ZIP_DEFLATED)
         olddir = os.getcwd()
         os.chdir(env['CD'])
         try: os.path.walk(env['PSV'], visit, zf)
@@ -340,17 +357,3 @@
 
     def unzipit(env, target, source):
         print "Unzipping %s:" % str(source[0])
-        zf = zipfile.ZipFile(str(source[0]), 'r')
-        for name in zf.namelist():
-            dest = os.path.join(env['UNPACK_ZIP_DIR'], name)
-            dir = os.path.dirname(dest)
-            try:
-                os.makedirs(dir)
-            except:
-                pass
-            print dest,name
-            # if the file exists, then delete it before writing
-            # to it so that we don't end up trying to write to a symlink:
-            if os.path.isfile(dest) or os.path.islink(dest):
-                os.unlink(dest)
-            if not os.path.isdir(dest):

=== debian/changelog ===
scons-doc (2.3.6+repack-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Move download and repack from debian/rules to uscan:
    - Add debian debian/repack.sh to debian/watch.
    - New debian/repack.sh.
    - Remove get-orig-source from debian/rules.
  * Rename source to +repack.
  * Add README.rst to debian/docs.

 -- Jörg Frings-Fürst <debian@jff-webhosting.net>  Sun, 02 Aug 2015 12:14:02 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: doc
 Priority: optional
 Maintainer: Jörg Frings-Fürst <debian@jff-webhosting.net>
-Uploaders: László Böszörményi <gcs@debian.org>
-Build-Depends: 
+Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Build-Depends:
  debhelper (>= 9),
  scons (>= 2.3)
-Build-Depends-Indep: 
+Build-Depends-Indep:
  docbook-utils,
  docbook-xml,
  fop,

## scons-doc 2.4.0+repack

=== SConstruct ===
--- 
+++ 
@@ -6,7 +6,7 @@
 copyright_years = '2001 - 2015'
 
 # This gets inserted into the man pages to reflect the month of release.
-month_year = 'July 2015'
+month_year = 'September 2015'
 
 #
 # Copyright (c) 2001 - 2015 The SCons Foundation
@@ -43,7 +43,7 @@
 import bootstrap
 
 project = 'scons'
-default_version = '2.3.6'
+default_version = '2.4.0'
 copyright = "Copyright (c) %s The SCons Foundation" % copyright_years
 
 platform = distutils.util.get_platform()

=== debian/changelog ===
scons-doc (2.4.0+repack-1) unstable; urgency=medium

  * New upstream release.

 -- Jörg Frings-Fürst <debian@jff-webhosting.net>  Mon, 28 Sep 2015 19:14:17 +0200
